
/***************************************************************************
                 module classe hmf_TF_dynadv_cen2.h  -  description
***************************************************************************/
// Mohamed Berrada
// locean-ipsl.upmc, Paris, February 27, 2009
//===========================================================================
//                          methode forward
forward (YREAL x1,YREAL x2,YREAL x3,YREAL x4,YREAL x5,YREAL x6)
{/*	x1	ua		1  i    j    k   t-1
	x2	ua		1  i+1  j    k   t-1
	x3	ua		1  i    j+1  k   t-1
	x4	va		1  i    j    k   t-1
	x5	va		1  i+1  j    k   t-1
	x6	va		1  i    j+1  k   t-1
*/
  if(Yt==TU){
    YS1=0.;
    YS2=0.;
    YS3=0.;
    YS4=0.;
  }
  else{
    double zfu, zfuip1,zfujp1;
    double zfv,zfvip1,zfvjp1;
    if(Yi==NX-1 || Yj==NY-1 || Yk==NZ-1){
      YS1=0.;
      YS2=0.;
      YS3=0.;
      YS4=0.;
    }
    else{
      zfu=0.25*(double)e2u(Yi,Yj)*(double)fse3v(Yi,Yj,Yk)*x1;
      zfuip1=0.25*(double)e2u(Yi+1,Yj)*(double)fse3v(Yi+1,Yj,Yk)*x2;
      zfujp1=0.25*e2u(Yi,Yj+1)*fse3v(Yi,Yj+1,Yk)*x3;
      
      zfv=0.25*e1v(Yi,Yj)*fse3v(Yi,Yj,Yk)*x4;
      zfvip1=0.25*e1v(Yi+1,Yj)*fse3v(Yi+1,Yj,Yk)*x5;
      zfvjp1=0.25*e1v(Yi,Yj+1)*fse3v(Yi,Yj+1,Yk)*x6;
      //zfu_t:
      YS1=(zfu+zfuip1)*(x1+x2);
      //zfv_f:
      YS2=(zfv+zfvip1)*(x1+x3);
      //zfu_f:
      YS3=(zfu+zfujp1)*(x4+x5);
      //zfv_t:
      YS4=(zfv+zfvjp1)*(x4+x6);
    }
  }
}

//===========================================================================
//                         methodes  backward

backward (YREAL x1,YREAL x2,YREAL x3,YREAL x4,YREAL x5,YREAL x6)
{
  YJ1I1=0.;     YJ1I2=0.;   YJ1I3=0.;     YJ1I4=0.;  YJ1I5=0.;     YJ1I6=0.;
  YJ2I1=0.;     YJ2I2=0.;   YJ2I3=0.;     YJ2I4=0.;  YJ2I5=0.;     YJ2I6=0.;
  YJ3I1=0.;     YJ3I2=0.;   YJ3I3=0.;     YJ3I4=0.;  YJ3I5=0.;     YJ3I6=0.;
  YJ4I1=0.;     YJ4I2=0.;   YJ4I3=0.;     YJ4I4=0.;  YJ4I5=0.;     YJ4I6=0.;
  
  if(Yt!=TU){  
    double zfu, zfuip1,zfujp1;
    double zfv,zfvip1,zfvjp1;
    if(Yi==NX-1 || Yj==NY-1 || Yk==NZ-1){
      YJ1I1=0.;     YJ1I2=0.;   YJ1I3=0.;     YJ1I4=0.;  YJ1I5=0.;     YJ1I6=0.;
      YJ2I1=0.;     YJ2I2=0.;   YJ2I3=0.;     YJ2I4=0.;  YJ2I5=0.;     YJ2I6=0.;
      YJ3I1=0.;     YJ3I2=0.;   YJ3I3=0.;     YJ3I4=0.;  YJ3I5=0.;     YJ3I6=0.;
      YJ4I1=0.;     YJ4I2=0.;   YJ4I3=0.;     YJ4I4=0.;  YJ4I5=0.;     YJ4I6=0.;
    }
    else{
      double dzfu_x1=0.,dzfuip1_x2=0.,dzfujp1_x3=0.,dzfv_x4=0.,dzfvip1_x5=0.,dzfvjp1_x6=0.;
      zfu        = 0.25*(double)e2u(Yi,Yj)*(double)fse3v(Yi,Yj,Yk)*x1;
      dzfu_x1    = 0.25*(double)e2u(Yi,Yj)*(double)fse3v(Yi,Yj,Yk);
      zfuip1     = 0.25*(double)e2u(Yi+1,Yj)*(double)fse3v(Yi+1,Yj,Yk)*x2;
      dzfuip1_x2 = 0.25*e2u(Yi+1,Yj)*fse3v(Yi+1,Yj,Yk);
      zfujp1     = 0.25*e2u(Yi,Yj+1)*fse3v(Yi,Yj+1,Yk)*x3;
      dzfujp1_x3 = 0.25*e2u(Yi,Yj+1)*fse3v(Yi,Yj+1,Yk);

      zfv        = 0.25*e1v(Yi,Yj)*fse3v(Yi,Yj,Yk)*x4;
      dzfv_x4    = 0.25*e1v(Yi,Yj)*fse3v(Yi,Yj,Yk);
      zfvip1     = 0.25*e1v(Yi+1,Yj)*fse3v(Yi+1,Yj,Yk)*x5;
      dzfvip1_x5 = 0.25*e1v(Yi+1,Yj)*fse3v(Yi+1,Yj,Yk);
      zfvjp1     = 0.25*e1v(Yi,Yj+1)*fse3v(Yi,Yj+1,Yk)*x6;
      dzfvjp1_x6 = 0.25*e1v(Yi,Yj+1)*fse3v(Yi,Yj+1,Yk);
      //zfu_t:
      YJ1I1=(zfu+zfuip1)+dzfu_x1*(x1+x2);
      YJ1I2=zfu+zfuip1+dzfuip1_x2*(x1+x2);
      //zfv_f:
      YJ2I1=zfv+zfvip1;
      YJ2I3=zfv+zfvip1;
      YJ2I4=dzfv_x4*(x1+x3);
      YJ2I5=dzfvip1_x5*(x1+x3);
      //zfu_f:
      YJ3I1=dzfu_x1*(x4+x5);
      YJ3I3=dzfujp1_x3*(x4+x5);
      YJ3I4=zfu+zfujp1;
      YJ3I5=zfu+zfujp1;
      //zfv_t:
      YJ4I4=dzfv_x4*(x4+x6)+zfv+zfvjp1;
      YJ4I6=dzfvjp1_x6*(x4+x6)+zfv+zfvjp1;
    }
  }
}

//===========================================================================
//********************* FIN DU MODULE hmf_TF_dynadv_cen2 **********************











