
/***************************************************************************
                 module classe sbcgyre_emp1.h  -  description
***************************************************************************/
// Mohamed Berrada
// locean-ipsl.upmc, Paris, Mars 18, 2009
// (jul) Evaporation minus Precipitation
//===========================================================================
//                          methode forward
forward ()
{ /*
    norm(emp1Y-emp1F)=9.634516907597773e-20
    norm(emp1Y-emp1F)/norm(empF)=1.944745312977350e-16
*/
  if(Yt==TU)
    YS1=0.;
  else{
    //      ! current day (in hours) since january the 1st of the current year
    /*    double  ztime = double(Yt-TU) * rdt / (rmmss * rhhmm)  //       !  total incrementation (in hours)
      - (nyear  - 1) * rjjhh * raajj;  //           !  minus years since beginning of experiment (in hours)
    */
    double  ztime = kt * rdt / (rmmss * rhhmm)  //       !  total incrementation (in hours)
      - (nyear  - 1) * rjjhh * raajj;  //           !  minus years since beginning of experiment (in hours)
    double  ztimemax1 = ((5.*30.)+21.)* 24.;//                     ! 21th june     at 24h in hours
    double  ztimemin1 = ztimemax1 + rjjhh * raajj / 2.;//            ! 21th december        in hours
    //double  ztimemax2 = ((6.*30.)+21.)* 24.;//                      ! 21th july     at 24h in hours
    //double  ztimemin2 = ztimemax2 - rjjhh * raajj / 2;//            ! 21th january         in hours
    // !                                                    ! NB: rjjhh * raajj / 4 = one seasonal cycle in hours
    
    //  ! amplitudes
    double  zemp_S    = 0.7;//       ! intensity of COS in the South
    double  zemp_N    = 0.8;//       ! intensity of COS in the North
    double  zemp_sais = 0.1;//
    
    //      ! 1/2 period between 21th June and 21th December and between 21th July and 21th January
    double  zcos_sais1 = cos( (ztime - ztimemax1) / (ztimemin1 - ztimemax1) * rpi );
    //double  zcos_sais2 = cos( (ztime - ztimemax2) / (ztimemax2 - ztimemin2) * rpi );
    
    double  zconv = 3.16e-5;      //! convertion factor: 1 m/yr => 3.16e-5 mm/s
    
    if( gphit(Yi,Yj) >= 14.845 && 37.2 >= gphit(Yi,Yj)) //    ! zero at 37.8 deg, max at 24.6 deg
      YS1 = zemp_S*zconv*sin(rpi/2.*(gphit(Yi,Yj)-37.2)/(24.6-37.2))*(1.-zemp_sais/zemp_S*zcos_sais1);
    else 
      YS1 = -zemp_N*zconv*sin(rpi/2.*(gphit(Yi,Yj)-37.2)/(46.8-37.2))*(1.-zemp_sais/zemp_N*zcos_sais1);
  }

  //
}

//===========================================================================
//                         methode  backward

backward ()
{
  
 }

  //===========================================================================
//********************* FIN DU MODULE sbc_gyre_emp1 **********************

