
/***************************************************************************
                 module classe zua_dhmf_dynadv_cen2.h  -  description
***************************************************************************/
// Mohamed Berrada
// locean-ipsl.upmc, Paris, February 27, 2009
//===========================================================================
//                          methode forward
forward (YREAL x1,YREAL x2,YREAL x3,YREAL x4)
{/*	x1	hmf_TF_dynadv_cen2		1  i    j    k   t
	x2	hmf_TF_dynadv_cen2		1  i-1  j    k   t
	x3	hmf_TF_dynadv_cen2		2  i    j    k   t
	x4	hmf_TF_dynadv_cen2		2  i    j-1  k   t*/
  if(Yt==TU)
    YS1=0.;
  else{
    double zbu;
    if(Yj>0 && Yj<NY-1 && Yk<NZ-1 && Yi>0 && Yi<NX-1){
      zbu=e1u(Yi,Yj)*e2u(Yi,Yj)*fse3u(Yi,Yj,Yk);
      YS1=-(x1-x2+x3-x4)/zbu;
    }
  }
  //
}

//===========================================================================
//                         methode  backward

backward (YREAL x1,YREAL x2,YREAL x3,YREAL x4)
{
  YJ1I1=0.;     YJ1I2=0.;   YJ1I3=0.;     YJ1I4=0.;
  if(Yt!=TU){  
    double zbu;
    if(Yj>0 && Yj<NY-1 && Yk<NZ-1 && Yi>0 && Yi<NX-1){
      zbu=e1u(Yi,Yj)*e2u(Yi,Yj)*fse3u(Yi,Yj,Yk);
      YJ1I1=-1./zbu;
      YJ1I2= 1./zbu;
      YJ1I3=-1./zbu;
      YJ1I4= 1./zbu;
    }
  }
  //
  
}

//===========================================================================
//********************* FIN DU MODULE zua_dhmf_dynadv_cen2 **********************
