
/***************************************************************************
                 module classe zva_dhmf_dynadv_cen2.h  -  description
***************************************************************************/
// Mohamed Berrada
// locean-ipsl.upmc, Paris, February 27, 2009
//===========================================================================
//                          methode forward
forward (YREAL x1,YREAL x2,YREAL x3,YREAL x4)
{/*	x1	hmf_TF_dynadv_cen2		3  i    j    k   t
	x2	hmf_TF_dynadv_cen2		3  i-1  j    k   t
	x3	hmf_TF_dynadv_cen2		4  i    j    k   t
	x4	hmf_TF_dynadv_cen2		4  i    j-1  k   t*/
  if(Yt==TU)
    YS1=0.;
  else{
    double zbv;
    if(Yi==0 || Yi==NX-1 || Yj==0 || Yj==NY-1 ||  Yk==NZ-1 )
      YS1=0.;
    else{
      zbv=e1v(Yi,Yj)*e2v(Yi,Yj)*fse3v(Yi,Yj,Yk);
      YS1=-(x1-x2+x3-x4)/zbv;
    }
  }
  if(Yi==1 && Yj==1 && Yk==2 && Yt==TU+2){
    /*    printf("xu(i,j)=%25.16e\n",x1);
    printf("xu(i-1,j)=%25.16e\n",x2);
    printf("xv(i,j)=%25.16e\n",x3);
    printf("xv(i,j-1)=%25.16e\n",x4);
    printf("YS1=%25.16e\n",YS1);*/
  }
}

//===========================================================================
//                         methode  backward

backward (YREAL x1,YREAL x2,YREAL x3,YREAL x4)
{
  YJ1I1=0.;     YJ1I2=0.;   YJ1I3=0.;     YJ1I4=0.;
  if(Yt!=TU){  
    double zbv;
    if(Yj>0 && Yj<NY-1 && Yk<NZ-1 && Yi>0 && Yi<NX-1){
      zbv=e1v(Yi,Yj)*e2v(Yi,Yj)*fse3v(Yi,Yj,Yk);
      YS1=-(x1-x2+x3-x4)/zbv;
      YJ1I1=-1./zbv;
      YJ1I2= 1./zbv;
      YJ1I3=-1./zbv;
      YJ1I4= 1./zbv;
    }
  }  
}

//===========================================================================
//********************* FIN DU MODULE zva_dhmf_dynadv_cen2 **********************
