
/***************************************************************************
                 module classe zwy_zfil.h  -  description
***************************************************************************/
// Mohamed Berrada
// locean-ipsl.upmc, Paris, July 21, 2011
//===========================================================================
//                          methode forward
forward (YREAL x1,YREAL x2)
{ /*	1	from	dta_zfil      		1  i 	j    k-1   t-1
	2	from	dta_zfil		1  i 	j    k     t-1 */

 //! first vertical derivative (gradient)

  if(Yt==1){
    YS1=0.;
  }
  else{
    if(Yi==0 || Yi==NX-1 || Yj==0 || Yj==NY-1 || Yk==NZ-1){
      YS1=0.;
    }
    else{
      double zave3r = 1.e0 / fse3w(Yi,Yj,Yk); //! 1 sur le pas veritcal au point w (Arakawa mesh)
      YS1 = avt_fil * ( x1 - x2) * zave3r;
    }
  }
  //
}

//===========================================================================
//                         methode  backward

backward (YREAL x1,YREAL x2)
{
  YJ1I1=0.;     YJ1I2=0.;

  if(Yt==1){
    YJ1I1=0.;     YJ1I2=0.;
  }
  else{
    if(Yi==0 || Yi==NX-1 || Yj==0 || Yj==NY-1 || Yk==NZ-1){
      YJ1I1=0.;     YJ1I2=0.;
    }
    else{
      double zave3r = 1.e0 / fse3w(Yi,Yj,Yk); //! 1 sur le pas veritcal au point w (Arakawa mesh)
      YJ1I1=avt_fil*zave3r;     YJ1I2=-avt_fil*zave3r;
    }
  }
  //

}
